/*Version 1.0.
  TNS SAS*/


// Incluye la libreria para el control de servomotores
#include <Servo.h>

// Define la constante para la lectura de la bateria, sensor y el led del boton
#define VBATPIN 9
#define SENSORPIN A1
#define LEDPIN 13
#define Sensor 12

// Crea los objetos Servo para control de los dedos
// TODO nombrar los dedos puntualmente
Servo menique;
Servo centro;
Servo indice;
Servo pulgar;
Servo basePulgar;

//Crea las diferentes variables y se inicializan
int pos = 100;
int sensorValue = 0;
int contador = 1;
int valores;
String estadoMano = "";
int value;
int cont = 0;
int sensorfiltradoant = 0;
int sensorfiltrado;
int sensor;
int cte = 5;

void setup() {


          // Inicializa la comunicacion por puerto serial a 9600 baudios
          Serial.begin(9600);
        
          // initialize digital pin 12 as an output.
          pinMode(LEDPIN, OUTPUT);
          pinMode(Sensor, OUTPUT);
          digitalWrite(Sensor, HIGH);
        
          // Se asignan los servos a sus puertos digitales correspondientes
          menique.attach(2);
          centro.attach(3);
          indice.attach(5);
          pulgar.attach(6);
          basePulgar.attach(11);

          // Llevan los servos a "Home"

          abrir();
          delay(200);
        
          // Se liberan los servos
          centro.detach();
          menique.detach();
          indice.detach();
          pulgar.detach();
          basePulgar.detach();
        
          sensor = analogRead(SENSORPIN);
          sensorfiltrado = (sensor + (sensorfiltradoant * cte)) / (cte + 1);
          sensorfiltradoant = sensorfiltrado;
          delay(100);
          sensor = analogRead(SENSORPIN);
          sensorfiltrado = (sensor + (sensorfiltradoant * cte)) / (cte + 1);
          sensorfiltradoant = sensorfiltrado;
          delay(100);
          sensor = analogRead(SENSORPIN);
          sensorfiltrado = (sensor + (sensorfiltradoant * cte)) / (cte + 1);
          sensorfiltradoant = sensorfiltrado;
          delay(100);
          sensor = analogRead(SENSORPIN);
          sensorfiltrado = (sensor + (sensorfiltradoant * cte)) / (cte + 1);
          sensorfiltradoant = sensorfiltrado;
          delay(100);
          sensor = analogRead(SENSORPIN);
          sensorfiltrado = (sensor + (sensorfiltradoant * cte)) / (cte + 1);
          sensorfiltradoant = sensorfiltrado;
          delay(100);

}


void loop() {

            //WARNING: No poner delays afuera del trigger del sensor
          
          
            // Lectura y escritura de estado de bateria, sensor y mano
            //     float measuredvbat = analogRead(VBATPIN);
            //     measuredvbat *= 2; // we divided by 2, so multiply back
            //     measuredvbat *= 3.3; // Multiply by 3.3V, our reference voltage
            //     measuredvbat /= 1024; // convert to voltage
            //     Serial.print("VBat: " ); Serial.println(measuredvbat);
            //     Serial.print("Estado Mano: " ); Serial.println(estadoMano);
          
            //     if(measuredvbat < 3.5 ){
            //     digitalWrite(LEDPIN, HIGH); // turn the LED on (HIGH is the voltage level)
            //     delay(250);
            //     digitalWrite(LEDPIN, LOW);
            //     delay(250);
            //     }
          
            sensor = analogRead(SENSORPIN);
            sensorfiltrado = (sensor + (sensorfiltradoant * cte)) / (cte + 1);
            sensorfiltradoant = sensorfiltrado;
            //Toma de lectura del sensor
            if (sensorfiltrado < 500) {
          
                          //Si el sensor detecta impulso
                          Serial.print("Sensor:  ");
                          Serial.println(sensorfiltrado);
                          //Si el sensor detecta un nuevo impulso despues del tiempo establecido
                          /* if(sensorValue<370){
                            cont=2;Serial.print("Sensor:  ");
                            Serial.println(value);
                            }
                          */
                          // Se asignan los servos a sus puertos digitales correspondientes
                          menique.attach(2);
                          centro.attach(3);
                          indice.attach(5);
                          pulgar.attach(6);
                          basePulgar.attach(11);
      
                                  if (estadoMano == "Abrir") {
                                          pinza();
                                          delay(800);
                                  }
                                  
                                 
                                  // Si detecta un impulso estando en Pinza                          
                                  else if (estadoMano == "Pinza") {
                                         abrir();
                                         delay(900);
                                  }

                          // Se liberan los servos
                          menique.detach();
                          indice.detach();
                          pulgar.detach();
                          centro.detach();
                          basePulgar.detach();
                        }
                        // Cuando no hay detección la variable a mostrar es cero.
              else {
                      
                          value = 0;
                      
                        }
            
            
            // Imprime el valor del sensor y la posición de la mano
          
            Serial.print("Sensor:  ");
            Serial.println(sensorfiltrado);
            Serial.print("Estado:  ");
            Serial.println(estadoMano);
            delay( 50);


}


/*
  PATRONES
*/

void abrir() {
  // TODO revisar los limites
  int pos = 0;    // variable to store the servo position
  pulgar.write(0);
  indice.write(0);
  centro.write(0);
  menique.write(0);
  
  
  
  delay(300);
  for (pos = 130; pos >= 50; pos -= 1) { // goes from 180 degrees to 0 degrees
    basePulgar.write(pos);              // tell servo to go to position in variable 'pos'
    delay(5);                       // waits 15ms for the servo to reach the position
  }
  //basePulgar.write(0); // tell servo to go to position in variable 'pos'

  // Espera por 15 milisegundos que los servos lleguen a la posicion
  delay(200);

  pos = 100;
  estadoMano = "Abrir";

}


void tarjeta() {

  menique.write(180);
  centro.write(180);
  indice.write(160);
  delay(300);
  pulgar.write(150);
  // Espera por 15 milisegundos que los servos lleguen a la posicion
  delay(200);

  pos = 100;
  estadoMano = "Tarjeta";

}

void pinza() {
  // TODO revisar los limites
  //basePulgar.write(90); // tell servo to go to position in variable 'pos'

  //
  int pos = 0;
   for (pos = 50; pos <= 150; pos += 1) { // goes from 0 degrees to 180 degrees
    // in steps of 1 degree
    basePulgar.write(pos);              // tell servo to go to position in variable 'pos'
    delay(4);                       // waits 15ms for the servo to reach the position
  } 
  delay(200);
  indice.write(150);
  centro.write(150);
  menique.write(150);
  delay(150);

  //basePulgar.write(90);
  delay(900);

  pulgar.write(150);


  // Espera por 15 milisegundos que los servos lleguen a la posicion
  delay(100);
  pos = 65;
  estadoMano = "Pinza";
}

void ok() {
  // TODO revisar los limites
  basePulgar.write(0);
  menique.write(180);
  centro.write(180);
  indice.write(180);
  delay(300);
  pulgar.write(0);


  // Espera por 15 milisegundos que los servos lleguen a la posicion
  delay(15);
  pos = 100;
  estadoMano = "Ok";
}

void apuntar() {
  // TODO revisar los limites
  indice.write(180);
  menique.write(180);
  centro.write(180);
  pulgar.write(180);
  basePulgar.write(50);
  delay(500);
  indice.write(0);


  // Espera por 15 milisegundos que los servos lleguen a la posicion
  delay(15);
  pos = 50;
  estadoMano = "Apuntar";
}

void puno() {
  // TODO revisar los limites

  basePulgar.write(50);
  delay(250);
  pulgar.write(180);
  delay(250);
  indice.write(180);
  menique.write(180);
  centro.write(180);


  // Espera por 15 milisegundos que los servos lleguen a la posicion
  delay(15);
  pos = 50;
  estadoMano = "Puno";
}
